//Air Hockey made by omundodogabriel
//Based on Pong game ported to Uzebox by DaveyPocket

#include <stdbool.h>
#include <avr/io.h>
#include <stdlib.h>
#include <math.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <uzebox.h>

#include "tiles.c"
#include "tilemap.map.inc"
#include "patches.inc"

#define Pluck 1
#define PADDLE1 5
#define PADDLE2 9

struct MySprite{
	unsigned char x;
	unsigned char y;
};

struct MySprite pBall;
struct MySprite Paddle[2];

void ProcessControls( void );
void ProcessBall( void );
void ProcessPaddles( void );
void ProcessScore( void );
void MoveSprites( void );
void InitGm ( void );

//Variables and stuff
unsigned char Score[2] = {0x00, 0x00};
bool Start = false;
bool BallOut = true;
bool GameOver = false;
bool Menu = true;
int choice1, choice2;
double X = 0x00, Y = 0x00;

int main(){
	//Set stuff up
	InitMusicPlayer(PongPatch);
	SetTileTable(HTiles); 
	SetFontTilesIndex(25);	
	SetSpritesTileTable(HTiles);	

	MapSprite(PADDLE1, paddle);
	MapSprite(PADDLE2, paddle);
	MapSprite(Pluck, hockeyball);
	
	FadeIn(2, false);
	TriggerFx(3, 0xff, true);
	
	while(1){
		if (Menu == true) {
			DrawMap(3, 4, Logo1);
			DrawMap(4, 10, Logo2);
			Print(0,27,PSTR("BY GSA"));
			
			if (choice1 == 0) {Print(3,17,PSTR(">1 PLAYER"));}else{Print(3,17,PSTR(" 1 PLAYER"));}
			if (choice1 == 0 && choice2 == 0) {Print(4,18,PSTR(">EASY"));}else{Print(4,18,PSTR(" EASY"));}
			if (choice1 == 0 && choice2 == 1) {Print(4,19,PSTR(">HARD"));}else{Print(4,19,PSTR(" HARD"));}
			if (choice1 == 1) {Print(16,17,PSTR(">2 PLAYERS"));}else{Print(16,17,PSTR(" 2 PLAYERS"));}
			
			if (ReadJoypad(0) != 0) {
				if (ReadJoypad(0) & BTN_LEFT) {
					if (choice1 != 0) {
						choice1 = 0;
						TriggerFx(0, 0xff, true);
					}
					
				}else if (ReadJoypad(0) & BTN_RIGHT) {
					if (choice1 != 1) {
						choice1 = 1;
						TriggerFx(0, 0xff, true);
					}
				}
				if (ReadJoypad(0) & BTN_UP) {
					if (choice2 != 0) {
						choice2 = 0;
						TriggerFx(0, 0xff, true);
					}					
				}else if (ReadJoypad(0) & BTN_DOWN) {
					if (choice2 != 1) {
						choice2 = 1;
						TriggerFx(0, 0xff, true);
					}					
				}
				if (ReadJoypad(0) & BTN_START) {InitGm();}
			}			
		}else{
			ProcessScore();
			ProcessControls();
			ProcessPaddles();
			ProcessBall();
			MoveSprites();
		}

	};
}


void ProcessControls( void ){
	unsigned int joypad1, joypad2 = 0x00;
	joypad1 = ReadJoypad(0);
	joypad2 = ReadJoypad(1);	
	
	if(joypad1&BTN_UP && Paddle[0].y > 112){
		if(joypad1&BTN_B){Paddle[0].y-=4;}else{Paddle[0].y-=2;}
	}else if (joypad1&BTN_DOWN && Paddle[0].y < 200){
		if(joypad1&BTN_B){Paddle[0].y+=4;}else{Paddle[0].y+=2;}
	}
	if (joypad1&BTN_LEFT && Paddle[0].x > 56){
		if(joypad1&BTN_B){Paddle[0].x-=4;}else{Paddle[0].x-=2;}
	}else if (joypad1&BTN_RIGHT && Paddle[0].x < 168){
		if(joypad1&BTN_B){Paddle[0].x+=4;}else{Paddle[0].x+=2;}
	}
	
	if (choice1 == 1) { //2 PLAYERS GAME
		if(joypad2&BTN_UP && Paddle[1].y > 8){
			if(joypad2&BTN_B){Paddle[1].y-=4;}else{Paddle[1].y-=2;}
		}else if (joypad2&BTN_DOWN && Paddle[1].y < 96){
			if(joypad2&BTN_B){Paddle[1].y+=4;}else{Paddle[1].y+=2;}
		}
		if (joypad2&BTN_LEFT && Paddle[1].x > 56){
			if(joypad2&BTN_B){Paddle[1].x-=4;}else{Paddle[1].x-=2;}
		}else if (joypad2&BTN_RIGHT && Paddle[1].x < 168){
			if(joypad2&BTN_B){Paddle[1].x+=4;}else{Paddle[1].x+=2;}
		}
	}else{ //1 PLAYER GAME (AI)
		//AI CODE GOES HERE ;)
		//choice2 = 0 EASY choice2 = 1 HARD
		if (Y < 0) { //Pluck is moving UP
			if (pBall.y > Paddle[1].y && Paddle[1].y < 96) {
				if (pBall.y + 40  > Paddle[1].y) {
					Paddle[1].y += 2;
				}else if(choice2 == 0){
					Paddle[1].y += 4;
				}
			}else if (pBall.y < Paddle[1].y && Paddle[1].y > 8){
				Paddle[1].y -= 2;
			}
			if (pBall.x > Paddle[1].x && Paddle[1].x < 168) {
				Paddle[1].x += 2;
			}else if (pBall.x < Paddle[1].x && Paddle[1].x > 56){
				Paddle[1].x -= 2;
			}
		}else{
			if (9 > Paddle[1].y) {Paddle[1].y += 2;}else if (9 < Paddle[1].y){Paddle[1].y -= 2;}
			if (112 > Paddle[1].x) {Paddle[1].x += 2;}else if (112 < Paddle[1].x){Paddle[1].x -= 2;}
		}		
	}


	if(joypad1&BTN_SELECT){
		SetSpriteVisibility(false);
		X = 0;
		Y = 0;
		BallOut = true;
		GameOver = true;
		
		TriggerFx(3, 0xff, true);
		ClearVram();
		FadeIn(2, false);
		Menu = true;
	}
}

void ProcessScore( void ){
	const int *numbers[8] = {n0, n1, n2, n3, n4, n5, n6, n7};
	if (Score[0] == 7 || Score[1] == 7){
		SetSpriteVisibility(false);
		X = 0;
		Y = 0;
		BallOut = true;
		GameOver = true;
	}
	DrawMap(1, 1, (numbers[Score[0]]));
	DrawMap(25, 22, (numbers[Score[1]]));
}

void ProcessPaddles( void ){
	if (pBall.x < Paddle[0].x + 16 && pBall.x + 16 > Paddle[0].x) {
		if (pBall.y < Paddle[0].y + 16 && pBall.y + 16 > Paddle[0].y) {
			X=(((pBall.x+16) - (Paddle[0].x+16))*(0.23/2));
			if (pBall.y > Paddle[0].y + 8) {
				if (ReadJoypad(0) & BTN_B) {Y = 4;}else{Y = 2;}
			}else{
				if (ReadJoypad(0) & BTN_B) {Y = -4;}else{Y = -2;}
			}
		}			
	}

	if (pBall.x < Paddle[1].x + 16 && pBall.x + 16 > Paddle[1].x) {
		if (pBall.y < Paddle[1].y + 16 && pBall.y + 16 > Paddle[1].y) {
			X=(((pBall.x+16) - (Paddle[1].x+16))*(0.23/2));
			if (pBall.y > Paddle[1].y + 8) {
				if (ReadJoypad(1) & BTN_B) {Y = 4;}else{Y = 2;}
			}else{
				if (ReadJoypad(1) & BTN_B) {Y = -4;}else{Y = -2;}
			}
		}
	}						
		
	WaitVsync(1);
}

void ProcessBall( void ){
	static double XX = 112, YY = 164;

	if(Start == true){
		Y = -1.5;
		Start = false;
		BallOut = false;
	}

	XX+=X;
	YY+=Y;
	pBall.x=XX;
	pBall.y=YY;

	if(pBall.x < 57 || pBall.x > 167){
		if (pBall.x < 120) {
			if (X < 1) {X*=-1;}
		}else{
			if (X > -1) {X*=-1;}
		}
		TriggerFx(1, 0xff, true);
	}
	
	if(pBall.y > 199 || pBall.y < 9){
		if (pBall.x > 95 && pBall.x < 129){
			BallOut = true;
			XX = 112;
			X = 0;
			Y = 0;

			if(pBall.y < 112){
				Score[1]++;
				YY = 44;
			}else{
				Score[0]++;
				YY = 164;
			}
			TriggerFx(2, 0xff, true);
		}else{
			if (pBall.y < 112) {
				if (Y < 1) {Y*=-1;}
				if (Y > 1) {Y-=1;}
			}else{
				if (Y > -1) {Y*=-1;}
				if (Y < -1) {Y+=1;}
			}
			TriggerFx(1, 0xff, true);			
		}
	}
}	

void MoveSprites( void ) {
	MoveSprite(PADDLE1,Paddle[0].x,Paddle[0].y, 2,2);
	MoveSprite(PADDLE2,Paddle[1].x,Paddle[1].y, 2,2);
	MoveSprite(Pluck, pBall.x, pBall.y, 2, 2);
}	

void InitGm( void ) {
	FadeOut(2, true);
	
	Menu = false;
	
	ClearVram();
	DrawMap(0, 0, court);
	
	SetSpriteVisibility(true);
	Score[0] = 0x00;
	Score[1] = 0x00;
	X = 0x00;
	Y = 0x00;
	GameOver = false;
	
	Paddle[0].x = 112;
	Paddle[1].x = 112;
	Paddle[0].y = 200;
	Paddle[1].y = 9;
	
	FadeIn(2, false);
}
